/// <reference types="webmidi" />
import { ImmSet } from 'immutable-map-set';
import { MessageQueue } from './message-queue';
import { SchedulerNode } from './scheduler-node';
import { SchedulerTargetNode } from './scheduler-target-node';
export declare class SchedulerEvent {
    id: string;
    midiEvent: {
        data: Uint8Array;
        receivedTime: number;
    };
    constructor(data?: Partial<SchedulerEvent>);
    toJSON(): {
        id: string;
        midiEvent: {
            receivedTime: number;
            data: Uint8Array;
        };
    };
}
export declare class SchedulerTarget {
    id: string;
    midiQueue: MessageQueue;
    constructor(data?: Partial<SchedulerTarget>);
}
export declare class SchedulerEventGroup {
    id: string;
    targets: ImmSet<SchedulerTarget>;
    events: ImmSet<SchedulerEvent>;
    loopPoints: Float64Array;
    constructor(eventGroup?: Partial<SchedulerEventGroup>);
    toJSON(): {
        id: string;
        targets: ImmSet<SchedulerTarget>;
        events: ImmSet<SchedulerEvent>;
        loopPoints: Float64Array;
    };
    get loop(): boolean;
    set loop(value: boolean);
    get loopStart(): number;
    set loopStart(seconds: number);
    get loopEnd(): number;
    set loopEnd(seconds: number);
    replaceAllWithNotes(notes: [number, number, number, number][]): WebMidi.MIDIMessageEvent[];
}
export declare class SchedulerEventGroupNode {
    schedulerNode: SchedulerNode;
    eventGroup: SchedulerEventGroup;
    constructor(schedulerNode: SchedulerNode);
    destroy(): void;
    connect(targetNode: SchedulerTargetNode): SchedulerTargetNode;
    disconnect(targetNode: SchedulerTargetNode): void;
}
